.release:
  stage: build
  tags:
  - packer

.dev-default:
  extends:
  - .release
  variables:
    VERSION: dev-${CI_MERGE_REQUEST_IID}-mr
  only:
    refs:
    - merge_requests

.dev:
  extends:
  - .dev-default
  script:
  - packer build -force packer.json
  environment:
    name: dev/gcp/${WINDOWS_VERSION}/${CI_COMMIT_REF_SLUG}

.dev stop:
  extends:
  - .dev-default
  image: google/cloud-sdk
  variables:
    GIT_STRATEGY: none
  script:
  - gcloud config set project $GOOGLE_PROJECT_ID
  - gcloud compute images delete runners-windows-$WINDOWS_VERSION-core-containers-$VERSION
  when: manual
  environment:
    name: dev/gcp/${WINDOWS_VERSION}/${CI_COMMIT_REF_SLUG}
    action: stop

dev 2019:
  extends:
  - .dev
  - .windows 2019
  environment:
    on_stop: dev stop 2019

dev stop 2019:
  extends:
  - .dev stop
  - .windows 2019

dev 1903:
  extends:
  - .dev
  - .windows 1903
  environment:
    on_stop: dev stop 1903

dev stop 1903:
  extends:
  - .dev stop
  - .windows 1903

dev 1909:
  extends:
  - .dev
  - .windows 1909
  environment:
    on_stop: dev stop 1909

dev stop 1909:
  extends:
  - .dev stop
  - .windows 1909

dev 2004:
  extends:
  - .dev
  - .windows 2004
  environment:
    on_stop: dev stop 2004

dev stop 2004:
  extends:
  - .dev stop
  - .windows 2004

.beta:
  extends:
  - .release
  script:
  - packer build -force packer.json
  variables:
    VERSION: beta
  environment:
    name: beta/gcp/${WINDOWS_VERSION}
  only:
    refs:
    - master@gitlab-org/ci-cd/shared-runners/images/gcp/windows-containers

beta 2019:
  extends:
  - .beta
  - .windows 2019

beta 1903:
  extends:
  - .beta
  - .windows 1903

beta 1909:
  extends:
  - .beta
  - .windows 1909

beta 2004:
  extends:
  - .beta
  - .windows 2004

.stable:
  extends:
  - .release
  script:
  - packer build packer.json
  variables:
    VERSION: ${CI_COMMIT_REF_NAME}
  environment:
    name: stable/gcp/${WINDOWS_VERSION}
  only:
    refs:
    - tags@gitlab-org/ci-cd/shared-runners/images/gcp/windows-containers

stable 2019:
  extends:
  - .stable
  - .windows 2019

stable 1903:
  extends:
  - .stable
  - .windows 1903

stable 1909:
  extends:
  - .stable
  - .windows 1909

stable 2004:
  extends:
  - .stable
  - .windows 2004

publish image 2019:
  extends:
  - .release
  - .windows 2019
  script:
  - export GOOGLE_PROJECT_ID=${PUBLISH_PROJECT_ID}
  - export GOOGLE_COMPUTE_ZONE=${PUBLISH_COMPUTE_ZONE}
  - export VERSION=$(date -I)
  - packer build packer.json
  environment:
    name: stable/gce
  when: manual

publish_image 1903:
  extends:
  - .release
  - .windows 1903
  script:
  - export GOOGLE_PROJECT_ID=${PUBLISH_PROJECT_ID}
  - export GOOGLE_COMPUTE_ZONE=${PUBLISH_COMPUTE_ZONE}
  - export VERSION=$(date -I)
  - packer build packer.json
  environment:
    name: stable/gce
  when: manual

publish image 1909:
  extends:
  - .release
  - .windows 1909
  script:
  - export GOOGLE_PROJECT_ID=${PUBLISH_PROJECT_ID}
  - export GOOGLE_COMPUTE_ZONE=${PUBLISH_COMPUTE_ZONE}
  - export VERSION=$(date -I)
  - packer build packer.json
  environment:
    name: stable/gce
  when: manual

publish image 2004:
  extends:
  - .release
  - .windows 2004
  script:
  - export GOOGLE_PROJECT_ID=${PUBLISH_PROJECT_ID}
  - export GOOGLE_COMPUTE_ZONE=${PUBLISH_COMPUTE_ZONE}
  - export VERSION=$(date -I)
  - packer build packer.json
  environment:
    name: stable/gce
  when: manual
